/*
Remote Access Session v0.6 scanhost.c - Code By Angel Ramos <seamus@salix.org>
*/

#include "raccess.h"

int connect_nonblock (int sockfd, struct sockaddr_in *host, socklen_t len , int sec)	{
	int flags, error, n;
	socklen_t elen;
	fd_set rset, wset;
	struct timeval time;

	if ((flags = fcntl (sockfd, F_GETFL, 0)) == -1)	{
		perror ("Fcntl error");
	}
	if (fcntl (sockfd, F_SETFL, flags | O_NONBLOCK) == -1)	{
		perror ("Fcntl error");
	}
	error = 0;
	if ((n = connect (sockfd, (struct sockaddr *) host, len)) < 0)	{
		if (errno != EINPROGRESS)	{
			return (-1);
		}
	}
	if (n == 0)	{
		goto done;
	}  
	FD_ZERO (&rset);
	FD_SET (sockfd, &rset);
	wset = rset;
	time.tv_sec = sec;
	time.tv_usec = 0;
	if ((n = select (sockfd + 1, &rset, &wset, NULL, 
		sec ? &time : NULL)) == 0)	{
		close (sockfd);
		errno = ETIMEDOUT;
		return (-1);
	}
	if (FD_ISSET (sockfd, &rset) || FD_ISSET(sockfd, &wset))	{
		elen = sizeof(error);
		if (getsockopt (sockfd, SOL_SOCKET, SO_ERROR, &error, 
			&elen) < 0)	{
			return (-1);
		}
	}
	
	done:

		if (fcntl (sockfd, F_SETFL, flags) == -1)	{
			perror ("Fcntl error");
		}
		if (error)	{
			close (sockfd);
			errno = error;
			return (-1);
		}
		return (0);
}

void try_connect (char *host, int port, int *osdetect)	{
	int sockfd;
	struct sockaddr_in remotehost;
	struct hostent *hp;
	struct servent *service;
	char *servicename;
	char *token;
	char bannerports[512];
	int bannerport;
	
	if (port == 53)	{
		if ((sockfd = socket (AF_INET, SOCK_DGRAM, 0)) == -1)	{
		perror  ("Socket error");
		}
	}	
	else {
		if ((sockfd = socket (AF_INET, SOCK_STREAM, 0)) == -1)	{
		perror  ("Socket error");
		}
	}	
	remotehost.sin_family = AF_INET;
	remotehost.sin_port = htons (port);
	hp = gethostbyname (host);
	if (hp == 0)	{
		fprintf (stderr, "Can't resolve %s.\n\n", host);
		unlink (host);
		exit (1);
	}
	memcpy ((char *)&remotehost.sin_addr, (char *)hp->h_addr, 
		hp->h_length);
	if (connect_nonblock (sockfd, &remotehost, sizeof remotehost
		, 5) != -1)	{
		if ((*osdetect == 1) && (port != 53))	{
			detectos (host, port);
			*osdetect = 0;
		}
		if ((service = getservbyport (remotehost.sin_port
			, NULL)) == NULL)	{
			servicename = "unknown";
		}
		else	{
			servicename = service->s_name;
		} 
		if (port == 53)	{
			printf ("\n--Checking named version...\n");
		}
		else	{
			printf ("\n--Service %s Port %d: Opened!!--\n"
			, servicename, port);
			if ((filedesc = fopen (host, "a")) == NULL)	{
				printf ("Can't open log file.\n");
			} else	{
				fprintf (filedesc, "--Service %s Port %d opened!!--\n"
				, servicename, port);
				fclose (filedesc);
			}
		}
		strncpy (bannerports, BANNER_PORTS, 512);
		token = strtok (bannerports, ",");
		bannerport = atoi (token);
		if (port == bannerport)	{
			extract_banner (sockfd, port, servicename, host);
		}
		while ((token = strtok (NULL, ",")) != NULL)	{
			bannerport = atoi (token);
			if  (port == bannerport)	{
				extract_banner (sockfd, port, servicename, host);
			}
		}
	}
	close (sockfd);
}

void scanhost (char *host, int osdetect, int onlyscan)	{
	int port;
	char scanports[512];
	char *tok;
	int i, n;
	char *array_ports[1];
	
	strncpy (scanports, PORTS, 512);
	tok = strtok_r (scanports, ",", array_ports);
	port = atoi (tok);
	try_connect (host, port, &osdetect);
	while ((tok = strtok_r (NULL, ",", array_ports)) != NULL)	{
		port = atoi (tok);
		try_connect (host, port, &osdetect);
	}
	printf ("\n~~~~~~~~~~~~~~~~\n");
	printf ("Scan Completed!!\n\n");
	if (onlyscan == 0)	{
		printf ("Starting attack session...\n");
		remote_attack (host);
	}
} 
 
